
import { Message, MessageReaction, User } from "discord.js";
import { logger, newRequestId, noGuildId } from "../logger";
import { NONE_OF_THAT } from "../constants";
import { client } from "../..";


export const name = 'messageReactionAdd'

export async function execute(messageReaction: MessageReaction, user: User) {
	if (user.id == client.user?.id)
		logger.info('Skipping bot reaction')
	const requestId = newRequestId()
	const guildId = messageReaction.message.inGuild() ? messageReaction.message.guildId : noGuildId
	const reactedUponMessage: Message = messageReaction.message.partial ? await messageReaction.message.fetch() : messageReaction.message
	if (!messageReaction.message.guild) {
		logger.warn(`Received messageReactionAdd on non-guild message.`, { requestId })
		return
	}

	logger.info(`Got reaction on message`, { requestId, guildId })
	//logger.debug(`reactedUponMessage payload: ${JSON.stringify(reactedUponMessage)}`)

	logger.info(`emoji: ${messageReaction.emoji.toString()}`)
	if (messageReaction.emoji.toString() === NONE_OF_THAT) {
		logger.info(`Reaction is NONE_OF_THAT. Handling`, { requestId, guildId })
		return client.VoteController.handleNoneOfThatVote(messageReaction, user, reactedUponMessage, requestId, guildId)
	}

	return
}
